package services

import (
	"xugu_license/internal/global"
	"xugu_license/internal/models"
)

func checkDistributeToUser(OaLicRequest string, UserUniqueIDs []string, UserNames []string) (licToUser []string, err error) {

	for i, UserUID := range UserUniqueIDs {

		//查询该license是否已经分发给了该用户
		if isTurn, err := models.CheckOaLicRequest(OaLicRequest, UserUID); err != nil {
			global.Logger.Errorln("该license查询是否分发给用户失败 ", UserUID, err.Error())
			return nil, err
		} else if isTurn {
			global.Logger.Info("该license已经分发给了该用户 ", UserUID, UserNames[i])
			licToUser = append(licToUser, UserNames[i])
		}

	}
	return licToUser, nil
}
