package main

import (
	"fmt"
	"xugu_license/internal"
	"xugu_license/internal/controllers"
	"xugu_license/internal/global"
)

func main() {
	global.InitDb()

	global.InitLogs(global.Cfg.Logs.LicLog, "info")

	err := global.XuguDB.Ping()
	if err != nil {
		fmt.Println("数据库连接失败")
		global.Logger.Errorln("数据库连接失败")
	} else {
		fmt.Println("数据库连接成功")
		global.Logger.Infoln("数据库连接成功")
	}
	err = controllers.InitRolesCache() // 初始化角色缓存
	if err != nil {
		global.Logger.Errorln("初始化角色缓存失败")
	}

	internal.HttpController()

}
